// Extracted From Omori BASE.js

var particlesEdit = particlesEdit || {};

Game_Actor.prototype.statusStateParticlesData = function () {
  // Get Main State
  var state = this.states()[0];
  // If State Exists
  if (state) {
    // If State Particle Data is not undefined
    if (state.meta.particlesData === undefined) {
      // Initialize State Particle Data
      state.meta.particlesData = {}
      // Get Layers
      var layers = ['Behind', 'Front', 'Top'];
      // Go through Layers
      for (var i = 0; i < layers.length; i++) {
        // Get Layer Name
        var layer = layers[i]
        // Instead of fetching the state's notetag metadata, instead check type of state to set up the particles
        // var particleName = state.meta["Particle" + layer];
        var particleName = particlesEdit.checkEmotion(state.name, layer);
        // If Particle Name Exists
        if (particleName) {
          // Set Particle Data for Particle Name
          state.meta.particlesData[layer.toLowerCase()] = particleName.trim().toLowerCase();
        };
      };
    };
    // Return State particle Data
    return state.meta.particlesData;
  };
  // Return default
  return null;
};

// -- Check emotion particles for proper player box layering placement, behind = behind portrait,
// front = infront of portrait, top = on top of player box --
particlesEdit.checkEmotion = function (state, layer) {
    var layer = layer.toLowerCase();
    var behind = (layer == "behind");
    var front = (layer == "front");
    var top = (layer == "top");
    switch (state.toLowerCase()) {
        case "angry":
            if (behind) {
                return "angry";
            };
            break;
        case "sad":
            if (front) {
                return "sad";
            };
            break;
        case "happy":
            if (behind) {
                return "happy";
            };
            break;
        case "enraged":
            if (behind) {
                return "enraged";
            };
            break;
        case "depressed":
            if (front) {
                return "depressed";
            };
            break;
        case "ecstatic":
            if (behind) {
                return "ecstatic";
            };
            break;
        case "furious":
            if (behind) {
                return "enraged";
            };
            break;
        case "miserable":
            if (front) {
                return "depressed";
            };
            break;
        case "manic":
            if (behind) {
                return "ecstatic";
            };
            break;
        default:
            return undefined;
    };
    return undefined;
};